<?php
/*

 $Id: zone.php 3544 2005-01-04 19:03:27Z philips $
 $HeadURL: https://svn.osuosl.org/public/maintain2/tags/release-2.4.2-RC2/modules/class/zone.php $

 Copyright (c) 2002 Oregon State University - Network Engineering
 All rights reserved.

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

/*!
	@header Zone Class
	This is the base zone class which shows all of the information
	about a zone and how its used.

*/

class Zone {
	/**
	 * Id number used in the DB
	 * @var		integer
	 * @access	public
	 */
	var $id;
	/**
	 * Name of the zone
	 * @var		string
	 * @access	public
	 */
	var $name;
	/**
	 * Description of the Zone, user settable
	 * @var		string
	 * @access	public
	 */
	var $description; 
	/**
	 * 
	 * @var		mixed
	 * @access	public
	 */
	var $purgeable;
	/**
	 * @var		mixed
	 * @access	public
	 */
	var $comment;
	/**
	 * Description of the Variable
	 * @var		mixed
	 * @access	public
	 */
	var $email;
	/**
	 * Description of the Variable
	 * @var		mixed
	 * @access	public
	 */
	var $notify;
	
	/**
	 * @see ObjectHistory
	 * @var ObjectHistory
	 * @access public
	 */
	var $object_history;

	function Zone ( $zone_id ) {
		global $conf;

		$this->id	     = $zone_id;
		
		if ($zone_id) { 
			$info = $this->get_info();
			$this->name          = $info->name;
			$this->description   = $info->description;
			if ($info->notify == 'enabled') { 
				$this->notify	     = 1;
			}
			$this->email	     = $info->support_mail;
			$this->purgeable     = $info->purgeable;
			$this->comment       = stripslashes($info->comment);
			$this->object_history = new ObjectHistory('zone',$zone_id);
		}

	} // constructor

	//gets the information for the zone
	function get_info() {
		global $conf;

		$sql = "SELECT * FROM zone WHERE id='$this->id'";
		$db_result = mysql_query($sql, $conf['dbh']);

		return mysql_fetch_object($db_result);		

	} //get_info

	// return an array of the hosts for this zone
	//   and sort according to the View object passed in
	function hosts ($view = false) {
		global $conf;

		if ( $view->sql ) {
			$sql = $view->sql;
		}
		elseif ( $view->sort_type == 'ip' ) {
			$sql = "SELECT * FROM host WHERE zone='$this->id'";
		}
		elseif ( $view->sort_type == 'domain' ) {
			$sql = "SELECT host.* 
					FROM host,$view->sort_type
					WHERE $view->sort_type.id=host.$view->sort_type
					AND zone='$this->id'";
		}
		else {
			$sql = "SELECT * FROM host
					WHERE zone='$this->id'";
		}

		// get the sort options from $view
		if ( ! $view ) {
			$sql .= " ORDER BY ip";
		}
		else {
			// the sort type of domain is troubling because we
			//   index the data type by ID in the host view.  So
			//   we need to be able to do an ORDER BY domain.name
			//   not just ORDER BY domain that the view object will
			//   return by default with get_query.  This is kludgy
			//   yes, but we haven't had to muck with the View object
			//   class definition.
			if ( $view->sort_type == 'domain' ) {
				$view->update_sort_type('domain.name');
				$sql .= $view->get_query();
				$view->update_sort_type('domain');
			}
			else {
				$sql .= $view->get_query();
			}
		}

		$db_result = mysql_query($sql, $conf['dbh']);

		$hosts = array();
		while ( $host = mysql_fetch_object($db_result) ) {
			$host_object = new Host($host->id);
			$hosts[] = $host_object;
		}

		return $hosts;
	}

	/*!
		@function domains
		@discussion get all enabled domains 
	*/
	function domains($zone_id = 0) {
		global $conf, $user;

		if (!$zone_id) { $sql = "SELECT zone_domain.* FROM zone_domain,domain WHERE zone_domain.zone='$this->id' AND zone_domain.domain=domain.id AND domain.enabled='1' ORDER by domain.name"; }
		elseif ($zone_id) { $sql = "SELECT DISTINCT zone_domain.* FROM zone_domain,domain WHERE zone_domain.zone='$zone_id' AND zone_domain.domain=domain.id AND domain.enabled='1' ORDER by domain.name"; }
		$db_results = mysql_query($sql, $conf['dbh']);
		
		while ($d = mysql_fetch_object($db_results) ) {
			$domain = new Domain($d->domain);
			$domains[] = $domain;	
		}
		return $domains; 
	} //domains		

	// return all of the cname records for this zone in
	//   the form of an array of CNAME objects
	function cnames($view = false) {
		global $conf;

		$sql = "SELECT * FROM zone_cname WHERE zone='$this->id'";
		
		if ( $view ) {
			$sql .= $view->get_query();
		}

		$db_result = mysql_query($sql, $conf['dbh']);

		$cnames = array();

		while ( $obj = mysql_fetch_object($db_result) ) {
			$cnames[] = new CNAME($obj->id);
		}

		return $cnames;
	}

	// return all of the mx records for this zone in
	//   the form of an array of MX objects
	function mxs($view = false) {
		global $conf;

		$sql = "SELECT * FROM zone_mx WHERE zone='$this->id'";
		
		if ( $view ) {
			$sql .= $view->get_query();
		}

		$db_result = mysql_query($sql, $conf['dbh']);

		$mxs = array();

		while ( $obj = mysql_fetch_object($db_result) ) {
			$mxs[] = new MX($obj->id);
		}

		return $mxs;
	}

	/*!
		@function get_workgroups
		@discussion gets all workgroups that are assoicated with 
			this zone
	*/
	function get_workgroups() {
		global $conf;

		$sql = "SELECT workgroup FROM zone_workgroup WHERE zone='$this->id'";
		$db_results = mysql_query($sql, $conf['dbh']);

		while ($r = mysql_fetch_object($db_results)) {
			$results[] = new Workgroup($r->workgroup);
		}

		return $results;

	} // get_workgroups

	/*!
		@function get_default_workgroup
		@discussion gets the default workgroup for this zone
	*/
	function get_default_workgroup() {
		global $conf;

		$sql = "SELECT workgroup FROM zone_workgroup WHERE zone='$this->id' AND is_default='1'";
		$db_results = mysql_query($sql, $conf['dbh']);

		return mysql_fetch_object($db_results);

	} // get_default_workgroup

	/*!
		@function get_host_os
		@discussion retrives a list of the distinct OS for this
			zone and returns it as an array of objects
	*/
	function get_host_os() {
		global $conf;

		$sql = "SELECT distinct(os) FROM host WHERE zone='$this->id' ORDER BY os ASC";
		$db_results = mysql_query($sql, $conf['dbh']);

		// Pulled as $results[$os] = $os so that it works with the generic 
		// show_select in ui.php
		while ($r = mysql_fetch_object($db_results)) {
			if ($r->os) { 
				$results[$r->os] = $r->os;
			}
		}

		return $results;

	} // get_host_os

	/*!
		@function get_host_hardware_type
		@discussion gets the distinct Hardware types in this 
			zone and returns it as an array of objects
	*/
	function get_host_hardware_type() {
		global $conf;

		$sql = "SELECT distinct(type) FROM host WHERE zone='$this->id' ORDER BY type ASC";
		$db_results = mysql_query($sql, $conf['dbh']);

		// Pulled as $results[$type] = $type so that it works with the generic
		// show_select in ui.php
		while ($r = mysql_fetch_object($db_results)) { 
			if ($r->type) { 
				$results[$r->type] = $r->type;
			}
		} // end while

		return $results;

	} // get_host_hardware_type

	// get any hosts which are in the host_history table but 
	// are not registered in maintain.. this is kinda tricky
	// grabs from $this (get's all in zone)
	function get_unregistered_hosts($date,$day_count=0) {
		global $conf;

		// First get all the ranges in this zone
		$ranges = $this->ip_ranges();
		
		// Create the sql statement from the ip ranges to pull any MAC's inside 
		// the ranges
		foreach ($ranges as $range) {
			$end = $range->end->ip_int;
			$start = $range->start->ip_int;
			if (!$sql) { $sql = "SELECT DISTINCT(host_history.ha),host_history.ip FROM host_history WHERE ( host_history.ip <= '$end' AND host_history.ip >= '$start' )"; }
			else { $sql .= " OR ( host_history.ip <= '$end' AND host_history.ip >= '$start') "; }

		} //end foreach

		// Add restriction to only $date
		if (!$day_count) { $day_count = 1; }
		$end_date = $date + ( 86400 * $day_count );
		$sql .= " AND host_history.date >= '$date' AND host_history.date <= '$end_date'";

		// Add a limit so it only shows the latest date field
		
		$db_results = mysql_query($sql, $conf['dbh']);

		//go through the results...
		while ($results = mysql_fetch_object($db_results)) { 
			$host_history[] = $results;
		} //end while
		
		if (!count($host_history)) { return false; }

		// Now recurse through and check them... once we are done 
		// we want to only return the unregistered ones
		foreach ($host_history as $host) {

			$sql = "SELECT id FROM host WHERE ha='$host->ha'";
			$db_results = mysql_query($sql, $conf['dbh']);

			// If we didn't find anything
			if (!$r = mysql_fetch_object($db_results)) {
				$results[] = $host;
			} //if not found

		} //end foreach

		return $results;

	} //get_unregistered_hosts

	// This function gets hosts that are incorrectly registered
	// The difference between this one, and the one above is that
	// This one checks HA & IP looking for an difference between
	// Host_History and the DB
	function get_confused_hosts($date,$day_count=0) {
		global $conf;

		// First get all the ranges in this zone
		$ranges = $this->ip_ranges();
		
		// Add restriction to only $date
		if (!$day_count) { $day_count = 1; }
		$end_date = $date + ( 86400 * $day_count );


		// Create the sql statement from the ip ranges to pull any MAC's inside 
		// the ranges
		foreach ($ranges as $range) {
			$end = $range->end->ip_int;
			$start = $range->start->ip_int;

			$sql = "SELECT DISTINCT(host_history.ha),host_history.ip,ranges.type,ranges.id as rangeid FROM host_history,ranges WHERE " .
			       "host_history.ip >= ranges.start AND host_history.ip <= ranges.end AND host_history.ip <= '$end' AND host_history.ip >= '$start'" .
			       " AND host_history.date >= '$date' AND host_history.date <= '$end_date'";
		
			$db_results = mysql_query($sql, $conf['dbh']);

			//go through the results...
			while ($results = mysql_fetch_object($db_results)) { 
				$host_history[] = $results;
			} //end while
	
		} //end foreach

		// Add a limit so it only shows the latest date field


		if (!count($host_history)) { return false; }

		// Now recurse through and check them... once we are done 
		// we want to only return the incorrectly set ones

		foreach ($host_history as $host) {

			if ($host->type == "dynamic" OR $host->type == "ddns") {
				$sql = "SELECT id FROM host WHERE ha='$host->ha' AND dynamic_range='$host->rangeid'";
			}
			else { 
				$sql = "SELECT id FROM host WHERE ha='$host->ha' AND ip='$host->ip'";
			}

			$db_results = mysql_query($sql, $conf['dbh']);

			// If we didn't find anything
			if (!$r = mysql_fetch_object($db_results)) {
				$results[] = $host;
			} //if not found

		} //end foreach

		return $results;

	} //get_unregistered_hosts


	// get the zone_range information and then create Range objects
	// don't do this by default as its pretty sql intensive
	function ip_ranges( $view = false ) {
		global $conf;

		$sql = "SELECT zone_range.range FROM ranges,zone_range WHERE ranges.id = zone_range.range AND zone_range.zone='$this->id' AND ranges.enabled='1' AND zone_range.enabled='1' ORDER BY ranges.start ASC";
		if ( $view ) {
			$sql .= $view->get_query();
		}

		$db_result = mysql_query($sql, $conf['dbh']);

		$ranges = array();

		while ( $obj = mysql_fetch_object($db_result) ) {
			$ranges[] = new Range($obj->range);
		}

		return $ranges;
	}

	//check to see if the zone has access to a specific ID returns the a object if found
	function has_domain_access($domain_id) {
			global $user, $conf;

			$sql = "SELECT * FROM zone_domain WHERE zone='$this->id' AND domain='$domain_id'";
			$db_results = mysql_query($sql, $conf['dbh']);

			return mysql_fetch_object($db_results);
	
	}

	function merge_zones($client_zone, $parent_zone) {
		global $conf, $user;

		//first let's move the hosts over
		$sql = "UPDATE host SET zone='$parent_zone' WHERE zone='$client_zone'";
		$db_results = mysql_query($sql, $conf['dbh']);

		//now let's do the cnames!
		$sql = "UPDATE zone_cname SET zone='$parent_zone' WHERE zone='$client_zone'";
		$db_results = mysql_query($sql, $conf['dbh']);
		
		//now let's do the mx records
		$sql = "UPDATE zone_mx SET zone='$parent_zone' WHERE zone='$client_zone'";
		$db_results = mysql_query($sql, $conf['dbh']);
		
		//build a list of duplicate domains
		$sql = "SELECT id,domain FROM zone_domain WHERE zone='$parent_zone' OR zone='$client_zone'";
		$db_results = mysql_query($sql, $conf['dbh']);

		while ($r = mysql_fetch_object($db_results) ) {
			//if it's not set yet then set it as true
			if (!$results[$r->domain]) { 
				$results[$r->domain] = true;
			}
			// if it's allready been found, (duplicate) then add it to the dups list
			elseif ($results[$r->domain]) {
				$dup[] = $r->id;
			}
		} //end while

		//run through the dups and nuke the mofo's
		if (count($dup)) {
			foreach ($dup as $data) {
				$sql = "DELETE FROM zone_domain WHERE id='$data'";
				$db_results = mysql_query($sql, $conf['dbh']);
			}
		} //if dups
		
		//Nuke the vars so they can be used again
		unset($results,$dup);

		//and now for the domains....
		$sql = "UPDATE zone_domain SET zone='$parent_zone' WHERE zone='$client_zone'";
		$db_results = mysql_query($sql, $conf['dbh']);

		
		//check for duplicate zone_range entries
		$sql = "SELECT id,range FROM zone_range WHERE zone='$parent_zone' OR zone='$client_zone'";
		$db_results = mysql_query($sql, $conf['dbh']);

		while ($r = mysql_fetch_object($db_results) ) { 

			//if it's not set yet then set it as true
                        if (!$results[$r->range]) { 
                                $results[$r->range] = true;
                        }
                        // if it's allready been found, (duplicate) then add it to the dups list
                        elseif ($results[$r->range]) {
                                $dup[] = $r->id;
			}
		} //end while	

		//if they are there then go through the duplicates and nuke them
		if (count($dup)) {
			foreach ($dup as $data) {
				$sql = "DELETE FROM zone_range WHERE id='$data'";
				$db_results = mysql_query($sql, $conf['dbh']);
			}
		} //if dups

		//Nuke the vars so they can be used again
		unset($results,$dup);

		//and now for ranges 
		$sql = "UPDATE zone_range SET zone='$parent_zone' WHERE zone='$client_zone'";
		$db_results = mysql_query($sql, $conf['dbh']);

		//check for duplicate zone_users
		$sql = "SELECT id,username FROM zone_user WHERE zone='$parent_zone' OR zone='$client_zone'";
		$db_results = mysql_query($sql, $conf['dbh']);

		while ($r = mysql_fetch_object($db_results)) {
                        //if it's not set yet then set it as true
                        if (!$results[$r->username]) {
                                $results[$r->username] = true;
                        }
                        //if it's allready been found, (duplicate) then add it to the dups list
                        elseif ($results[$r->username]) {
                                $dup[] = $r->id;
                        }						
		} //end while

		if (count($dup)) { 
			foreach ($dup as $data) {
				$sql = "DELETE FROM zone_user WHERE id='$data'";
				$db_results = mysql_query($sql, $conf['dbh']);
			} //end foreach
		} //if dup
		
		//replace zone users
		$sql = "UPDATE zone_user SET zone='$parent_zone' WHERE zone='$client_zone'";
		$db_results = mysql_query($sql, $conf['dbh']);

		//Nuke the vars so they can be used again
		unset($results,$dup);

		//all of the records should have been updated now let's nuke the old zone entry
		$sql = "DELETE FROM zone WHERE id='$client_zone'";
		$db_results = mysql_query($sql, $conf['dbh']);
						

	} //merge_zones
	
	//wipes out all the hosts in a specific zone
	function purge_zone($zone_id) { 
		global $conf;
		$zone = new Zone($zone_id);
		//let's double check to make sure that this zone can be purged 		
		if ($zone->purgeable == "true") { 
			//ok we can purge the mofo, let's rock!		
			$sql = "DELETE FROM host WHERE zone='$zone->id'";
			$db_results = mysql_query($sql, $conf['dbh']);
		}		

	} //purge_zone

	//nukes the zone
	function delete_zone($zone_id) {
		global $conf, $user;

		//first nuke the zone table entry
		$sql = "DELETE FROM zone WHERE id='$zone_id'";
		$db_results = mysql_query($sql, $conf['dbh']);
		
		//second nuke the user -> zone table entries
		$sql = "DELETE FROM zone_user WHERE zone='$zone_id'";
		$db_results = mysql_query($sql, $conf['dbh']);
		
	} //delete_zone

	//nukes the link between a domain and a zone... doesn't delete the domain though!
	function remove_domain($zone_id,$domain_id) {
	
		global $conf;

		$sql = "DELETE FROM zone_domain WHERE domain='$domain_id' AND zone='$zone_id'";
		$db_results = mysql_query($sql, $conf['dbh']);

	} //remove_domain

	/*!
		@function check_name
		@discussion checks to make sure the zone name is a valid name
	*/
	function check_name($name,$zone_id) {
		global $user, $conf;

		//first let's make sure it isn't in there already
		$sql = "SELECT * FROM zone WHERE name LIKE '$name' AND id!='$zone_id'";
		$db_results = mysql_query($sql, $conf['dbh']);
		if (mysql_fetch_object($db_results)) {
				$conf['error']->add_error('name', "$name was already found in the database, please pick a different name and try again.");
				return false;
		}
		
		//now let's make sure that there aren't any invalid chr's
		//  we can allow alpha-numeric words and spaces
		if (!(preg_match("/^[\s\w\.\_\-]+$/", $name))) {
			$conf['error']->add_error('name', "$name is an invalid zone name.");
			return false;
		}

	return true;

	} // check_name

	/*!
		@function new_zone
		@discussion takes a name description and comment 
			and creates a new zone.
	*/
	function new_zone($name, $description, $comment) {

		$name = sql_escape($name);
		$description = sql_escape($description);
		$comment = sql_escape(htmlentities($comment));

		//insert it into the zone table.. and we are done
		$sql = "REPLACE INTO zone (name,description,comment) VALUES ('$name','$description','$comment')";
		$db_results = mysql_query($sql, dbh());
		$zone_id = mysql_insert_id(dbh());		

		return $zone_id;
	} //new_zone

	/*!
		@function update_name
		@discussion updates the name of the zone... nuff said
	*/
	function update_name($name) {

		$name = sql_escape($name);

		$sql = "UPDATE zone SET name='$name' WHERE id='$this->id'";
		$db_results = mysql_query($sql, dbh());


	} //update_name


	/*!
		@function update_comment
		@discussion updates the comment for the zone... 
	*/
	function update_comment ($comment) {

		$comment = sql_escape(htmlentities($comment));

		$sql = "UPDATE zone SET comment='$comment' WHERE id='$this->id'";
		$db_results = mysql_query($sql, dbh());

		$this->comment = $comment;

		
	} //update_comment

	/*!
		@function update_notify
		@discussion sets the notify flag, this determins if the users
			of this zone want to recieve e-mails everytime a full
			admin makes a change to their zone
	*/
	function update_notify($new_notify) {
	
		$new_notify = sql_escape($new_notify);
	
		$sql = "UPDATE zone SET notify='$new_notify' WHERE id='$this->id'";
		$db_results = mysql_query($sql, dbh());

		$this->notify = $new_notify;

	} // update_notify

	/*!
		@function update_email
		@discussion this updates the support e-mail contact for this zone
	*/
	function update_email($new_email) {

		$new_email = sql_escape($new_email);

		$sql = "UPDATE zone SET support_mail='$new_email' WHERE id='$this->id'";
		$db_results = mysql_query($sql, dbh());

		$this->email = $new_email;

	} // update_email

	/*!
		@function add_domain
		@discussion adds a domain as an allowed in this zone. 
	*/
	function add_domain($zone_id,$domain_id){
		
		$sql = "REPLACE INTO zone_domain (zone,domain) VALUES ($zone_id,$domain_id)";
		$db_results = mysql_query($sql, dbh());
		
	} //add_domain

	/*!
		@function ip_ranges_count
		@discussion counts the number of ranges that this zone has access to 
	*/
	function ip_ranges_count () {

		$sql = "SELECT count(*) FROM zone_range WHERE zone='$this->id'";
		$db_result = mysql_query($sql, dbh());

		$count = mysql_fetch_row($db_result);
		return $count[0];
	} // ip_ranges_count

	/*!
		@function dynamic_ranges_count
		@discussion this counts the total number of dynamic ranges 
			in  _this_ zone
	*/
	function dynamic_ranges_count () {
		global $conf;

		$sql = "SELECT count(*) FROM ranges,zone_range WHERE zone_range.zone='$this->id' AND ranges.type='dynamic'";
		$db_result = mysql_query($sql, $conf['dbh']);

		$count = mysql_fetch_row($db_result);
		return $count[0];
	} // dynamic_ranges_count

	/*!
		@function get_users
		@discussion this returns an array of users
			objects who have access to this zone
	*/
	function get_users () {

		$sql = "SELECT DISTINCT username FROM zone_user WHERE zone='$this->id'";
		$db_result = mysql_query($sql, dbh());	

		$users = array();

		while ( $u = mysql_fetch_object($db_result) ) {
			$temp_user = new User($u->username,'','',true);
			$users[] = $temp_user;
		}	

		return $users;
	} // get_users

	/*!
		@function get_user
		@discussion gets a specific user from this zone
	*/
	function get_user ($user_id) {

		$sql = "SELECT * FROM zone_user WHERE id=$user_id AND zone='$this->id'";
		$db_result = mysql_query($sql, dbh());

		$u = mysql_fetch_object($db_result);
		return new User($u->username);
	} // get_user

	/*!
		@function add_zone_user
		@discussion Add a user with access to this zone 
			w/ the given access level
	*/
	function add_zone_user ($username, $level) {
		global $conf, $user;

		$username = sql_escape($username);

		// check to make sure they aren't already in there
		$sql = "SELECT username FROM zone_user WHERE username='$username' AND zone='$this->id'";
		$db_results = mysql_query($sql, $conf['dbh']);

		$results = mysql_fetch_object($db_results);
		
		// this is not the place to add an admin -- do that elsewhere
		if ( ( $level == '50' || $level == '25' || $level == '5' ) && !$results) {
			$sql = "INSERT INTO zone_user (username,level,zone) VALUES ('$username', '$level', $this->id)";
			$db_result = mysql_query($sql, $conf['dbh']);
		}
		elseif ($level == '50' || $level == '25' || $level == '5' ) {
			$sql = "UPDATE zone_user SET level='$level' WHERE username='$username' AND zone='$this->id'";
			$db_results = mysql_query($sql, $conf['dbh']);
		}


	} // add_zone_user

	/*!
		@function delete_user
		@discussion remove a user from access to this zone (this is the user_id from zone_user)
	*/
	function delete_user ($user_id,$delete_all=0) {
		global $user;

		if ($user->is_admin && $delete_all) { 
			$sql = "DELETE FROM zone_user WHERE username='$user_id'";
		}
		elseif ($delete_all) {
			$zones = $user->get_zone_admin_zones();
			$sql = "DELETE FROM zone_user WHERE username='$user_id' AND"; 
			foreach($zones as $zone) {
				if ($i) { $sql .= " OR zone='$zone->id' "; }
				else { $sql .= " ( zone='$zone->id' "; }
				$i = 1;
			} // end foreach

			$sql .= ")";
		} 
		else {
			$sql = "DELETE FROM zone_user WHERE username='$user_id' AND zone='$this->id'";
		}

		
		$db_result = mysql_query($sql, dbh());


	} // delete_user

	// update a user's access level within this zone (again, user_id is for zone_user)
	function set_user_level ($user_id, $level) {
		global $conf;

		// cannot change to admin here
		if ( $level != 100 ) {
			$sql = "UPDATE zone_user SET level='$level' WHERE username='$user_id' AND zone='$this->id'";
			$db_result = mysql_query($sql, $conf['dbh']);
		}
	}

	// update the purgeable flag to the reverse of what it currently is
	function update_purgeable () {
		global $conf;

		if ( $this->purgeable == 'true' ) {
			mysql_query("UPDATE zone SET purgeable='false' WHERE id=$this->id", $conf[dbh]);

			$this->purgeable = 'false';
		}
		else {
			mysql_query("UPDATE zone SET purgeable='true' WHERE id=$this->id", $conf[dbh]);
			$this->purgeable = 'true';
		}

	} // update_purgeable

/* Move to Host */
	// create a host ... duh
	function create_host ($name, $domain_id, $ip, $dynamic_range, $ha, $os, $type, $location, $serial, $other_id, $range_id, $workgroup_id, $who_update,$purchase_date,$po_number,$warranty_date,$owning_unit,$user_id,$expire,$ttl) {
		global $conf,$user;
	
		$last_update 	= time();
		$name 		= sql_escape($name);
		$ha		= sql_escape($ha);
		$location	= sql_escape($location);
		$serial		= sql_escape($serial);
		$other_id	= sql_escape($other_id);
		$purchase_date	= sql_escape($purchase_date);
		$po_number	= sql_escape($po_number);
		$warranty_date	= sql_escape($warranty_date);
		$owning_unit	= sql_escape($owning_unit);
		$user_id	= sql_escape($user_id);
		$expire		= sql_escape($expire);
		$ttl		= sql_escape($ttl);
		$type		= sql_escape($type);

		$sql = "INSERT INTO host (name,domain,ip,dynamic_range,ha,os,type,location,serial,other_id,workgroup,zone,purchase_date,po_number,warranty_date,owning_unit,user_id,expire,ttl)
				VALUES ('$name', $domain_id, $ip, '$dynamic_range', '$ha', '$os', '$type', '$location',
				'$serial', '$other_id', '$workgroup_id', '$this->id', '$purchase_date' , '$po_number' ,
				'$warranty_date', '$owning_unit', '$user_id','$expire','$ttl')";
		$db_result = mysql_query($sql, dbh());
		$host_id   = mysql_insert_id(dbh());

		//Create the new host object and update the object history, basicly creation date
		if ($host_id) { 
			$host = new Host($host_id);
			$host->object_history->update($user->username);
		}
		else {
			echo "<p>Something Bad has just happened.. please send a e-mail to maintain-devel@lists.orst.edu with the below information, the SQL query failed: <br /><br />$sql</p>";
			die;
		}

		return $host_id;
		
	} // create_host

/* Move to Domain */
	// insert the given domain or return the ID of the specified domain
	function insert_domain($domain_name) {
		global $conf;

		$domain = sql_escape($domain);

		// check that the new domain doesn't already exist -- if it does, use that ID?
		$sql = "SELECT id FROM domain WHERE name='$domain_name'";
		$db_result = mysql_query($sql, $conf['dbh']);

		if ( $domain_id = mysql_fetch_row($db_result) ) {
			return $domain_id[0];
		}
		else {
			$sql = "INSERT INTO domain (name) VALUES ('$domain_name')";
			$db_result = mysql_query($sql, $conf['dbh']);
			return mysql_insert_id($conf['dbh']);
		}
	}

/* Rename Function */
	// insert the given domain_id into the zone_domain for $this zone
	function insert_domain_zone($domain) {
		global $conf;
		// check that the domain isn't already in this table
		$sql = "SELECT id FROM zone_domain WHERE domain=$domain AND zone=$this->id";
		$db_result = mysql_query($sql, $conf['dbh']);

		if ( $zone_domain_id = mysql_fetch_row($db_result) ) {
			return $zone_domain_id;
		}
		else {
			$sql = "INSERT INTO zone_domain (zone,domain) VALUES ('$this->id', '$domain')";
			$db_result = mysql_query($sql, $conf['dbh']);	

			return mysql_insert_id($conf['dbh']);
		}
	}
/* Move to Cname */
	// insert a cname for this zone to the specified server
	function insert_cname ($name, $domain, $server) {
		global $conf;

		$name = sql_escape($name);
		$domain	= sql_escape($domain);
		$server = sql_escape($server);

		$sql = "INSERT INTO zone_cname (name,domain,server,zone) VALUES ".
			"('$name', $domain, '$server', '$this->id')";

		$db_result = mysql_query($sql, $conf['dbh']);
		return mysql_insert_id($conf['dbh']);
	}

	/**
	* See whether blank hardware addresses are allowed 
	*
	* @return	bool	true if it is allowed / false if it isn't
	*/
	function get_allow_blank_ha () {
		$sql = "SELECT allow_blank_ha FROM zone WHERE id='$this->id'";

		$db_result = mysql_query($sql, dbh());
		
		$row = mysql_fetch_row($db_result);

		return $row[0];
	}
	
	/**
	* @param bool $allow	setting blank hardware addresses allowed in this
	*						zone
	*
	* @return resource Returns the result of the query.
	*/
	function set_allow_blank_ha ($allow) {
		$sql = "UPDATE zone SET allow_blank_ha='$allow' WHERE id='$this->id'";

		$db_result = mysql_query($sql, dbh());
		
		return $db_result;
	}	

	function _show () {
		print_r(get_object_vars($this));
	}
}

?>
