<?php

/*

$Id: show_domain.inc 3544 2005-01-04 19:03:27Z philips $
 $HeadURL: https://svn.osuosl.org/public/maintain2/tags/release-2.4.2-RC2/templates/show_domain.inc $

 Copyright (c) 2002 Oregon State University - Network Engineering
 All rights reserved.

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

/*!
	@header Show Domain
	Template for viewing/editing a single domain

*/

// for those who don't have a zone set
if ($conf['zone']) { $domains = $conf['zone']->domains(); }

//create the object_history 
$history = $domain->object_history->get_history();

$items = array();
if ($user->has_access($domain->zone->id)) { 
	$items[] = "<a href=\"" . $conf['web_path'] . "/domain.php?action=show_domain&domain_id=". $domain->id ."\">Edit</a>";
	$items[] = "<a href=\"" . $conf['web_path'] .  "/domain.php?action=confirm_delete_domain&domain_id=" . $domain->id . "\">Delete</a>";
}
$items[] = "<a href=\"" . $conf['web_path'] . "/create_domain.php\">Create New Domain</a>";
$items[] = "<a href=\"" . $conf['web_path'] . "/domain.php?action=show_domains\">Show Domains</a>";
$conf['ui']->display_top_widget($items);
?>

<? if ($action_type) { ?>
<? show_template('tborder'); ?>
<table border="0" cellpadding="2" cellspacing="0" width="100%" bgcolor="<? echo $conf['light_bgcolor']?>">
        <tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>" width="100%">
                <td title="<? $conf['help']->title('domain'); ?>"><? $conf['help']->show_link('domain'); ?>Domain: </td>
                <td align="left"><? $conf['ui']->display_field($domain->name); ?>
                </td>
        </tr>
        <tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
                <td title="<? $conf['help']->title('domain_parent_zone'); ?>"><? $conf['help']->show_link('domain_parent_zone'); ?> Parent Zone(s): </td>
                <td><form style="Display:inline">
			<?
			$zones = $domain->zones();
			$conf['ui']->show_zone_select($zones, $zones[0]);
			?>
			</form>
                </td>
        </tr>
	<tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
		<td title="<? $conf['help']->title('domain_status'); ?>"><? $conf['help']->show_link('domain_status'); ?> Status:</td>
		<td>
		<? $conf['ui']->display_field($domain->get_enabled_string()); ?>
		</td>
	</tr>
</table>
<? show_template('bborder'); ?>
<? } else { ?>
<? show_template('tborder'); ?>
<table border="0" cellpadding="2" cellspacing="0" width="100%">
	<tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
		<td colspan="3" class="header2">Updating <?= $domain->name; ?></td>
	</tr>
	<tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
    		<td title="<? $conf['help']->title('domain'); ?>"><? $conf['help']->show_link('domain'); ?> Domain: </td>
                <td><form enctype="multipart/form-data" method="post" action="<?= $conf['web_path']; ?>/domain.php" style="Display:inline">
                        <input type="textbox" name="name" value="<? echo $domain->name ?>" size="35" />
			<input type="hidden" name="domain_id" value="<?= $domain->id; ?>" />
			<input type="hidden" name="action" value="update_name" />
			<? if ($conf['error']->get_status('name') ) { $conf['error']->show_message('name'); } ?>
                </td>
		<td><input type="submit" value="Update Name" />
		</form>
		</td>
	</tr>
	<tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
		<td title="<? $conf['help']->title('domain_new_zone'); ?>"><? $conf['help']->show_link('domain_new_zone'); ?> Add <? echo $domain->name; ?> to another Zone.</td>
		<td><form style="Display:inline" action="<?= $conf['web_path']; ?>/domain.php" method="post" enctype="multipart/form-data" >
		<input type="hidden" name="action" value="add_zone" />
		<input type="hidden" name="domain_id" value="<?= $domain->id; ?>" />
		<? //add mojo time
		$zones = $user->zones();
		$conf['ui']->show_zone_select($zones, $zones[0]);
		?></td><td>
		<input type="submit" value="Add Zone" /></form>
		</td>
	</tr>
	<tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
		<td title="<? $conf['help']->title('domain_remove_zone'); ?>"><? $conf['help']->show_link('domain_remove_zone'); ?> Remove <? echo $domain->name; ?> from a Zone.</td>
		<td><form style="Display:inline" action="<?= $conf['web_path']; ?>/domain.php" method="post" enctype="multipart/form-data">
		<input type="hidden" name="action" value="confirm_remove_zone" />
		<input type="hidden" name="domain_id" value="<?= $domain->id; ?>" />
		<? //remove mojo time
		$zones = $domain->zones();
		$conf['ui']->show_zone_select($zones,$zones[0]);
		?></td><td>
		<input type="submit" value="Remove Zone" />
		</form>
		</td>
	</tr>
	<tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
		<td title="<? $conf['help']->title('generic_comment'); ?>" valign="top" ><? $conf['help']->show_link('generic_comment'); ?>
			 Comment:
	                <a href="<?= $conf['web_path']; ?>/help.php?action=show_comments&amp;object_id=<?= $domain->id; ?>&amp;object_name=<?= $domain->name; ?>&amp;object_type=domain">
                        [View All Comments]    
                        </a>
                </td>
                <td>
		<form style="Display:inline" action="<?= $conf['web_path']; ?>/domain.php" method="post" enctype="multipart/form-data">
                <textarea name="comment" cols="45" rows="5"><?= $history->comment; ?></textarea>
                </td>
		<td valign="top">
		<input type="hidden" name="action" value="update_comment" />
		<input type="hidden" name="domain_id" value="<?= $domain->id; ?>" />
		<input type="submit" value="Update Comment" />
		</form>
	</tr>
        <tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
                <td title="<? $conf['help']->title('domain_status'); ?>"><? $conf['help']->show_link('domain_status'); ?> Status:</td>
                <td>
                <? $conf['ui']->display_field($domain->get_enabled_string()); ?>
                </td>

		<td>
			<form style="Display:inline" action="<?= $conf['web_path']; ?>/domain.php?action=update_status" method="post" enctype="multipart/form-data">
			<input type="hidden" name="domain_id" value="<?= $domain->id; ?>" />
			<? if (!$domain->is_enabled()) { ?>
			<input type="hidden" name="newstatus" value="1" />
			<input type="submit" value="Enable" />
			<? } else { ?>
			<input type="hidden" name="newstatus" value="0" />
			<input type="submit" value="Disable" />
			<? } ?>
		</td>
        </tr>
        <tr bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
                <td title="<? $conf['help']->title('who_update'); ?>"><? $conf['help']->show_link('who_update'); ?> Last Updated By: </td>
                <td colspan="2">
                <? if ($history->username) { ?>
                        <? $conf['ui']->display_field($history->username); ?><?= " on " . date("F j, Y",$history->date) . " at " . date("g:i a",$history->date); ?>
                <? } else { ?>
                        N/A
                <? } ?>
                </td>
        </tr>

</table>
<? show_template('bborder'); ?>
<input type="hidden" name="domain_id" value="<?= $domain->id ?>" />

</form>
<? } ?>
