<?php

/*

 $Id: show_ranges.inc 3544 2005-01-04 19:03:27Z philips $
 $HeadURL: https://svn.osuosl.org/public/maintain2/tags/release-2.4.2-RC2/templates/show_ranges.inc $

 Copyright (c) 2002 Oregon State University - Network Engineering
 All rights reserved.

 This program is free software; you can redistribute it and/or
 modify it under the terms of the GNU General Public License
 as published by the Free Software Foundation; either version 2
 of the License, or (at your option) any later version.

 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

/*!
	@header Show Many Ranges Template
	Show a listing of the $ranges (an array of Range objects)

*/

show_template('tborder'); 

$conf['ui']->show_list_header($total_items); 


?>

<table border="0" cellpadding="2" cellspacing="0" width="100%">
	<tr align="center" bgcolor="<?= $conf['color']->bg['body_dark']; ?>">
    		<td><a href="<?= $conf['web_path'] . "/" . $conf['script'] ?>?action=show_ranges&sort_type=start"  title="<? $conf['help']->title("range"); ?>">Range</a></td>
                <td>Free Addresses</td>
                <td>Default Domain</td>
                <td><a href="<?= $conf['web_path'] . "/" . $conf['script'] ?>?action=show_ranges&sort_type=type" title="<? $conf['help']->title("range_type"); ?>">Type</a></td>
		<? if ( $admin_view ) { ?>
                <td><a href="<?= $conf['web_path'] . "/" . $conf['script'] ?>?action=show_ranges&sort_type=zone" title="<? $conf['help']->title("zone"); ?>">Zone</a></td>
                <td align="center"><a href="<?= $conf['web_path'] . "/" . $conf['script'] ?>?action=show_ranges&sort_type=default_workgroup" title="<? $conf['help']->title("workgroup"); ?>">Workgroup</a></td>
		<? } // if ?>
                <td align="center">Action</td>
	</tr>

<?

foreach ($ranges as $range) {

?>

	<tr align="center" bgcolor="<? $conf['ui']->alternate_bgcolor(); ?>">
		<td><? $conf['ui']->display_field($range->start->ip_addr); ?> to <? $conf['ui']->display_field($range->end->ip_addr); ?></td>
		<td><? $conf['ui']->display_field($range->get_free_address_count()); ?></td>
		<td><? $conf['ui']->display_field($range->default_domain->name); ?></td>
		<td><? $conf['ui']->display_field($range->type); ?></td>
		<? if ( $admin_view ) {
			$zone = new Zone($range->zone);
			$workgroup = new Workgroup($range->default_workgroup);
		?>
		<td><? $conf['ui']->display_field($zone->name); ?></td>
		<td><? $conf['ui']->display_field($workgroup->name); ?></td>
		<?
			$zone = '';
			$workgroup = '';
		} //if ?>
		<td align="center">
<?

if ( $host->id && $range->type == 'static' && $range->get_free_address_count() ) {

?>
			<a href="<?= $conf['web_path']; ?>/ip.php?action=select_random_ip&amp;zone_range=<?= $range->id; ?>&amp;host_id=<?= $host->id; ?>">Select Random IP</a> |
			<a href="<?= $conf['web_path']; ?>/ip.php?action=show_available_ips&amp;zone_range=<?= $range->id; ?>&amp;host_id=<?= $host->id; ?>">View Available IPs</a>
<? 
} // elseif
elseif ( $host->id && $range->type == 'dynamic') {
?>
	<a href="<?= $conf['web_path']; ?>/ip.php?action=select_ip&amp;range_id=<?= $range->id; ?>&amp;host_id=<?= $host->id; ?>">Set to Dynamic</a> |

<?
} // elseif 
elseif ( $user->is_admin ) {
?>
	<a href="<?= $conf['web_path']; ?>/range.php?action=edit&amp;range_id=<?= $range->id ?>">Edit</a> |
	<? if ($range->type == "static") { ?>
	<a href="<?= $conf['web_path']; ?>/range.php?action=show_split&amp;range_id=<?= $range->id; ?>">Split</a> |
	<a href="<?= $conf['web_path']; ?>/range.php?action=show_merge&amp;range_id=<?= $range->id; ?>">Merge</a> |
	<a href="<?= $conf['web_path']; ?>/ip.php?action=show_available_ips&amp;zone_range=<?= $range->id; ?>">View Available IPs</a> |
	<? } ?>
	<a href="<?= $conf['web_path']; ?>/range.php?action=delete&amp;range_id=<?= $range->id ?>">Delete</a> 
	<?
} // elseif
elseif ($user->is_zone_admin) { 
?>
	<? if ($range->type == "static") { ?>
		<a href="<?= $conf['web_path']; ?>/ip.php?action=show_available_ips&amp;zone_range=<?= $range->id; ?>">View Available IPs</a>
	<? } ?>
<? 
} //check for zone_admin

else {
?>
		<a href="<?= $conf['web_path']; ?>/ip.php?action=show_available_ips&amp;zone_range=<?= $range->id ?>">View Available IPs</a>
<? } // else ?>

		</td>
	</tr>
<?
} // foreach
?>

</table>

<?
$conf['ui']->show_list_header($total_items);
show_template('bborder'); 
?>


